<template>
  <div>
    <h3>{{ poll.name }}</h3>
    <p>{{ poll.question }}</p>
    <poll-form :answers="poll.answers" @vote="vote($event)"/>
  </div>
</template>

<script>
import axios from "axios";
import PollForm from "@/components/PollForm";

export default {
  name: 'poll',
  components: {
    PollForm
  },
  data: function() {
    return {
      poll: Object,
      pollId: this.$route.params.id
    }
  },
  methods: {
    vote: function(selectedAnswer) {
      axios.patch(`http://127.0.0.1:3000/answers/${selectedAnswer.id}/vote`, selectedAnswer)
      .then(() => {
        this.$router.push({ name: 'result', params: { id: this.poll.id }})
      })
    }
  },
  mounted: function() {
    axios.get(`http://127.0.0.1:3000/polls/${this.pollId}?_embed=answers`)
      .then((response) => this.poll = response.data)
  }
}
</script>
